import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.lang.*;

/**
 * Insert the type's description here.
 * Creation date: (21/02/2001 13:55:51)
 * @author: Administrator
 */
public class Subdiv extends Applet {
	
	
	/***********************************************************************************************/
	/***********************************************************************************************/
	
	
	private Button ivjbDecompose 						= null;
	private Button ivjbReconstruct 					= null;
	private Button ivjbSubdivide 						= null;
	private Button ivjbUndo 								= null;
	private Button ivjbCompress 						= null;
	private Button ivjbLoadCircle 					= null;
	private Button ivjbLoadHeart 						= null;
	private Button ivjbLoadLissajou					= null;
	private Button ivjbLoadLoop 						= null;
	private Button ivjbHistogramm 					= null;
	private Button ivjbReset 								= null;
	
	private TextField ivjtfCompress 				= null;
	
	private Checkbox ivjcbCurve 						= null;
	private Checkbox ivjcbDecomposedCurve 	= null;
	private Checkbox ivjcbCompressedCurve 	= null;
	private Checkbox ivjcbDetails 					= null;
	private Checkbox ivjcbPolygon 					= null;
	private Checkbox ivjcbControlPoints 		= null;
	private Checkbox ivjcbDecomposedPolygon = null;
	private Checkbox ivjcdDecomposedPoints 	= null;

	
	private Label ivjlNbControlPoints 			= null;
	private Label ivjlNbDecompositions 			= null;
	private Label ivjlNbPoints 							= null;
	private Label ivjnbControlPoints				= null;
	private Label ivjnbDecompositions 			= null;
	private Label ivjnbPoints 							= null;
	private Label ivjlDecomposedCurve 			= null;
	private Label ivjlInitialCurve 					= null;
	private Label ivjlnbControlPointsDecomposed = null;
	private Label ivjlnbPointsDecomposed 		= null;	
	private Label ivjnbDecomposedControlPoints = null;
	private Label ivjnbDecomposedPoints 		= null;
	private Label ivjlNbSubdiv 							= null;
	private Label ivjnbSubdiv 							= null;
	
	private Panel ivjcontrolPanel 					= null;
	private Panel ivjdrawingPanel 					= null;

	IvjEventHandler ivjEventHandler 				= new IvjEventHandler();
	
	protected subdivCurve sc;
	protected subdivCurve sc2;
	protected subdivCurve sc3;
	
	protected int nbControlPoints;
	protected int nbDecompositions;
	protected int nbSubdivisions;
	protected int slices;
	protected int state;	
	
	protected boolean showControlPoints;
	protected boolean showDecomposedControlPoints;
	protected boolean showDecomposedCurve;
	protected boolean showCompressedCurve;
	protected boolean showDecomposedPolygon;
	protected boolean showDetails;
	protected boolean showInitialCurve;
	protected boolean showInitialPolygon;	
	

	/***********************************************************************************************/
	/***********************************************************************************************/	
	
	
	class IvjEventHandler implements java.awt.event.ItemListener, java.awt.event.MouseListener, java.awt.event.MouseMotionListener {
	
		public void itemStateChanged(java.awt.event.ItemEvent e) {
			if (e.getSource() == Subdiv.this.getcbDetails()) 
				connEtoC5(e);
			if (e.getSource() == Subdiv.this.getcbDecomposedPolygon()) 
				connEtoC6(e);
			if (e.getSource() == Subdiv.this.getcbDecomposedCurve()) 
				connEtoC7(e);
			if (e.getSource() == Subdiv.this.getcbPolygon()) 
				connEtoC8(e);
			if (e.getSource() == Subdiv.this.getcbControlPoints()) 
				connEtoC9(e);
			if (e.getSource() == Subdiv.this.getcdDecomposedPoints()) 
				connEtoC10(e);
			if (e.getSource() == Subdiv.this.getcbCurve()) 
				connEtoC19(e);
			if (e.getSource() == Subdiv.this.getcbCompressedCurve()) 
				connEtoC21(e);		
		};
		
		public void mouseClicked(java.awt.event.MouseEvent e) {
			if (e.getSource() == Subdiv.this.getbSubdivide()) 
				connEtoC1(e);
			if (e.getSource() == Subdiv.this.getbUndo()) 
				connEtoC2(e);
			if (e.getSource() == Subdiv.this.getbDecompose()) 
				connEtoC3(e);
			if (e.getSource() == Subdiv.this.getbReconstruct()) 
				connEtoC4(e);
			if (e.getSource() == Subdiv.this.getbHistogramm()) 
				connEtoC11(e);				
			if (e.getSource() == Subdiv.this.getbLoadCircle()) 
				connEtoC12(e);
			if (e.getSource() == Subdiv.this.getbLoadHeart()) 
				connEtoC13(e);
			if (e.getSource() == Subdiv.this.getbLoadLissajou()) 
				connEtoC14(e);
			if (e.getSource() == Subdiv.this.getbLoadLoop()) 
				connEtoC15(e);
			if (e.getSource() == Subdiv.this.getdrawingPanel()) 
				connEtoC16(e);				
			if (e.getSource() == Subdiv.this.getbReset()) 
				connEtoC18(e);
			if (e.getSource() == Subdiv.this.getbCompress()) 
				connEtoC20(e);	
				
		};
		
		public void mouseDragged(java.awt.event.MouseEvent e) {
			if (e.getSource() == Subdiv.this.getdrawingPanel()) 
				connEtoC17(e);	
		};

		
		public void mouseEntered(java.awt.event.MouseEvent e) {};
		public void mouseExited(java.awt.event.MouseEvent e) {};
		public void mouseMoved(java.awt.event.MouseEvent e) {};
		public void mousePressed(java.awt.event.MouseEvent e) {};
		public void mouseReleased(java.awt.event.MouseEvent e) {};
		
	};
	
	
	/***********************************************************************************************/
	/***********************************************************************************************/
	
	
/**
 * Comment
 */
public void bDecompose_MouseClicked(java.awt.event.MouseEvent mouseEvent) {

	if (sc2.decompose() && sc3.decompose()) {
		nbDecompositions++;
		repaint();paintall();
	}	
	
}

/**
 * Comment
 */
public void bReconstruct_MouseClicked(java.awt.event.MouseEvent mouseEvent) {
	
	if (sc2.reconstruct() && sc3.reconstruct()) {
		nbDecompositions--;	
		repaint();paintall();		
	}
	
}

/**
 * Comment
 */
public void bSubdivide_MouseClicked(java.awt.event.MouseEvent mouseEvent) {
	sc.subdivideOneTime();
	sc2.subdivideOneTime();
	sc3.subdivideOneTime();
	nbSubdivisions++;
	repaint();paintall();
}

/**
 * Comment
 */
public void bUndo_MouseClicked(java.awt.event.MouseEvent mouseEvent) {
	if (sc.undoSubdivision()) {
		sc2.undoSubdivision();
		sc3.undoSubdivision();
		nbSubdivisions--;
		repaint();paintall();
	}

}

/**
 * Comment
 */
public void bLoadCircle_MouseClicked(java.awt.event.MouseEvent mouseEvent) {

	double coef;
	int x,y;

	reset();
	
	for(int i=0;i<128;i++) {
		x = (int) ( Math.cos((double)i*2*3.1415/128.0)*200+300 );
		y = (int) ( Math.sin((double)i*2*3.1415/128.0)*200+300 );
		sc.addControlPoint(x,y);
		sc2.addControlPoint(x,y);
		sc3.addControlPoint(x,y);
		nbControlPoints++;
	}

	repaint();paintall();	
	
}

/**
 * Comment
 */
public void bLoadHeart_MouseClicked(java.awt.event.MouseEvent mouseEvent) {

	double coef;
	int x,y;

	reset();
	  
	for(int i=0;i<128;i++) {
		x = (int) ( Math.cos((double)i*3.1415/128.0)*300*Math.sin((double)i*3.1415/128.0)+300 );
		y = (int) ( 200-Math.sin((double)i*3.1415/128.0)*300*Math.cos((double)i*3.1415/64.0));
		sc.addControlPoint(x,y);
		sc2.addControlPoint(x,y);
		sc3.addControlPoint(x,y);		
		nbControlPoints++;
	}

	repaint();paintall();

}

/**
 * Comment
 */
public void bLoadLissajou_MouseClicked(java.awt.event.MouseEvent mouseEvent) {
	double coef;
	int x,y;

	reset();
	  
	for(int i=0;i<128;i++) {
		x = (int) ( Math.cos((double)i*3*2*3.1415/128.0)*200+300 );
		y = (int) ( Math.sin((double)i*5*2*3.1415/128.0)*200+300 );
		sc.addControlPoint(x,y);
		sc2.addControlPoint(x,y);
		sc3.addControlPoint(x,y);
		nbControlPoints++;
	}

	repaint();paintall();
	
}

/**
 * Comment
 */
public void bLoadLoop_MouseClicked(java.awt.event.MouseEvent mouseEvent) {
	double coef;
	int x,y;

	reset();
	
	for(int i=0;i<128;i++) {
		x = (int) ( Math.cos((double)i*2*3.1415/128.0)*160+300 );
		y = (int) ( Math.sin((double)i*2*2*3.1415/128.0)*160+300 );
		sc.addControlPoint(x,y);
		sc2.addControlPoint(x,y);
		sc3.addControlPoint(x,y);
		nbControlPoints++;
	}

	repaint();paintall();
}


	/***********************************************************************************************/
	/***********************************************************************************************/


/**
 * connEtoC1:  (bSubdivide.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bSubdivide_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bSubdivide_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC2:  (bUndo.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bUndo_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC2(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bUndo_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC3:  (bDecompose.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bDecompose_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC3(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bDecompose_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC4:  (bReconstruct.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bReconstruct_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC4(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bReconstruct_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC5:  (cbDetails.item.itemStateChanged(java.awt.event.ItemEvent) --> Subdiv.cbDetails_ItemStateChanged(Ljava.awt.event.ItemEvent;)V)
 * @param arg1 java.awt.event.ItemEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC5(java.awt.event.ItemEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.cbDetails_ItemStateChanged(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC6:  (cbDecomposedPolygon.item.itemStateChanged(java.awt.event.ItemEvent) --> Subdiv.cbDecomposedPolygon_ItemStateChanged(Ljava.awt.event.ItemEvent;)V)
 * @param arg1 java.awt.event.ItemEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC6(java.awt.event.ItemEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.cbDecomposedPolygon_ItemStateChanged(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC7:  (cbDecomposedCurve.item.itemStateChanged(java.awt.event.ItemEvent) --> Subdiv.cbDecomposedCurve_ItemStateChanged(Ljava.awt.event.ItemEvent;)V)
 * @param arg1 java.awt.event.ItemEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC7(java.awt.event.ItemEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.cbDecomposedCurve_ItemStateChanged(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC8:  (cbPolygon.item.itemStateChanged(java.awt.event.ItemEvent) --> Subdiv.cbPolygon_ItemStateChanged(Ljava.awt.event.ItemEvent;)V)
 * @param arg1 java.awt.event.ItemEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC8(java.awt.event.ItemEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.cbPolygon_ItemStateChanged(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC9:  (cbControlPoints.item.itemStateChanged(java.awt.event.ItemEvent) --> Subdiv.cbControlPoints_ItemStateChanged(Ljava.awt.event.ItemEvent;)V)
 * @param arg1 java.awt.event.ItemEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC9(java.awt.event.ItemEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.cbControlPoints_ItemStateChanged(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC10:  (cdDecomposedPoints.item.itemStateChanged(java.awt.event.ItemEvent) --> Subdiv.cdDecomposedPoints_ItemStateChanged(Ljava.awt.event.ItemEvent;)V)
 * @param arg1 java.awt.event.ItemEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC10(java.awt.event.ItemEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.cdDecomposedPoints_ItemStateChanged(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC11:  (bHistogramm.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bHistogramm_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC11(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bHistogramm_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC12:  (bLoadCircle.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bLoadCircle_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC12(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bLoadCircle_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC13:  (bLoadHeart.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bLoadHeart_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC13(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bLoadHeart_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC14:  (bLoadLissajou.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bLoadLissajou_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC14(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bLoadLissajou_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC15:  (bLoadLoop.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bLoadLoop_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC15(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bLoadLoop_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC16:  (drawingPanel.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.drawingPanel_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC16(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.drawingPanel_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC17:  (drawingPanel.mouseMotion.mouseDragged(java.awt.event.MouseEvent) --> Subdiv.drawingPanel_MouseDragged(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC17(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.drawingPanel_MouseDragged(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC18:  (bReset.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bReset_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC18(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bReset_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC19:  (cbCurve.item.itemStateChanged(java.awt.event.ItemEvent) --> Subdiv.cbCurve_ItemStateChanged(Ljava.awt.event.ItemEvent;)V)
 * @param arg1 java.awt.event.ItemEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC19(java.awt.event.ItemEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.cbCurve_ItemStateChanged(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC20:  (bCompress.mouse.mouseClicked(java.awt.event.MouseEvent) --> Subdiv.bCompress_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC20(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.bCompress_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * connEtoC21:  (cbCompressedCurve.item.itemStateChanged(java.awt.event.ItemEvent) --> Subdiv.cbCompressedCurve_ItemStateChanged(Ljava.awt.event.ItemEvent;)V)
 * @param arg1 java.awt.event.ItemEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC21(java.awt.event.ItemEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.cbCompressedCurve_ItemStateChanged(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}


	/***********************************************************************************************/
	/***********************************************************************************************/


/**
 * Return the Button3 property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbDecompose() {
	if (ivjbDecompose == null) {
		try {
			ivjbDecompose = new java.awt.Button();
			ivjbDecompose.setName("bDecompose");
			ivjbDecompose.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbDecompose.setBounds(25, 325, 150, 25);
			ivjbDecompose.setLabel("Decompose");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbDecompose;
}

/**
 * Return the Button4 property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbReconstruct() {
	if (ivjbReconstruct == null) {
		try {
			ivjbReconstruct = new java.awt.Button();
			ivjbReconstruct.setName("bReconstruct");
			ivjbReconstruct.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbReconstruct.setBounds(24, 355, 150, 25);
			ivjbReconstruct.setLabel("Reconstruct");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbReconstruct;
}

/**
 * Return the Button1 property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbSubdivide() {
	if (ivjbSubdivide == null) {
		try {
			ivjbSubdivide = new java.awt.Button();
			ivjbSubdivide.setName("bSubdivide");
			ivjbSubdivide.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbSubdivide.setBounds(25, 265, 150, 25);
			ivjbSubdivide.setLabel("Subdivide");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbSubdivide;
}

/**
 * Return the Button2 property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbUndo() {
	if (ivjbUndo == null) {
		try {
			ivjbUndo = new java.awt.Button();
			ivjbUndo.setName("bUndo");
			ivjbUndo.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbUndo.setBounds(26, 295, 150, 25);
			ivjbUndo.setLabel("Undo subdivision");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbUndo;
}

/**
 * Return the Button1 property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbCompress() {
	if (ivjbCompress == null) {
		try {
			ivjbCompress = new java.awt.Button();
			ivjbCompress.setName("bCompress");
			ivjbCompress.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbCompress.setBounds(25, 205, 75, 25);
			ivjbCompress.setLabel("Compress");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbCompress;
}

/**
 * Return the Button1 property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbLoadCircle() {
	if (ivjbLoadCircle == null) {
		try {
			ivjbLoadCircle = new java.awt.Button();
			ivjbLoadCircle.setName("bLoadCircle");
			ivjbLoadCircle.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbLoadCircle.setBounds(2, 390, 96, 25);
			ivjbLoadCircle.setLabel("Load circle");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbLoadCircle;
}

/**
 * Return the Button3 property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbLoadHeart() {
	if (ivjbLoadHeart == null) {
		try {
			ivjbLoadHeart = new java.awt.Button();
			ivjbLoadHeart.setName("bLoadHeart");
			ivjbLoadHeart.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbLoadHeart.setBounds(103, 390, 96, 25);
			ivjbLoadHeart.setLabel("Load heart");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbLoadHeart;
}

/**
 * Return the Button2 property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbLoadLissajou() {
	if (ivjbLoadLissajou == null) {
		try {
			ivjbLoadLissajou = new java.awt.Button();
			ivjbLoadLissajou.setName("bLoadLissajou");
			ivjbLoadLissajou.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbLoadLissajou.setBounds(2, 420, 96, 25);
			ivjbLoadLissajou.setLabel("Load lissajou");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbLoadLissajou;
}

/**
 * Return the Button4 property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbLoadLoop() {
	if (ivjbLoadLoop == null) {
		try {
			ivjbLoadLoop = new java.awt.Button();
			ivjbLoadLoop.setName("bLoadLoop");
			ivjbLoadLoop.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbLoadLoop.setBounds(103, 420, 96, 25);
			ivjbLoadLoop.setLabel("Load loop");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbLoadLoop;
}

/**
 * Return the bReset property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbReset() {
	if (ivjbReset == null) {
		try {
			ivjbReset = new java.awt.Button();
			ivjbReset.setName("bReset");
			ivjbReset.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbReset.setBounds(25, 175, 150, 25);
			ivjbReset.setLabel("Reset");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbReset;
}

/**
 * Return the Button1 property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Button getbHistogramm() {
	if (ivjbHistogramm == null) {
		try {
			ivjbHistogramm = new java.awt.Button();
			ivjbHistogramm.setName("bHistogramm");
			ivjbHistogramm.setFont(new java.awt.Font("Arial", 1, 14));
			ivjbHistogramm.setBounds(25, 235, 150, 25);
			ivjbHistogramm.setLabel("Histogramm");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbHistogramm;
}


	/***********************************************************************************************/
	/***********************************************************************************************/


/**
 * Return the testField property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.TextField gettfCompress() {
	if (ivjtfCompress == null) {
		try {
			ivjtfCompress = new java.awt.TextField();
			ivjtfCompress.setName("tfCompress");
			ivjtfCompress.setFont(new java.awt.Font("Arial", 1, 14));
			ivjtfCompress.setBounds(105, 205, 75, 25);
			//ivjtfCompress.setLabel("Compress");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjtfCompress;
}


	/***********************************************************************************************/
	/***********************************************************************************************/


/**
 * Return the Checkbox3 property value.
 * @return java.awt.Checkbox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Checkbox getcbCurve() {
	if (ivjcbCurve == null) {
		try {
			ivjcbCurve = new java.awt.Checkbox();
			ivjcbCurve.setName("cbCurve");
			ivjcbCurve.setFont(new java.awt.Font("Arial", 1, 14));
			ivjcbCurve.setBounds(10, 460, 200, 20);
			ivjcbCurve.setLabel("Initial curve");
			ivjcbCurve.setState(true);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjcbCurve;
}

/**
 * Return the cbDecomposedCurve property value.
 * @return java.awt.Checkbox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Checkbox getcbDecomposedCurve() {
	if (ivjcbDecomposedCurve == null) {
		try {
			ivjcbDecomposedCurve = new java.awt.Checkbox();
			ivjcbDecomposedCurve.setName("cbDecomposedCurve");
			ivjcbDecomposedCurve.setFont(new java.awt.Font("Arial", 1, 14));
			ivjcbDecomposedCurve.setBounds(10, 480, 200, 20);
			ivjcbDecomposedCurve.setLabel("Decomposed curve");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjcbDecomposedCurve;
}

/**
 * Return the cbCompressedCurve property value.
 * @return java.awt.Checkbox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Checkbox getcbCompressedCurve() {
	if (ivjcbCompressedCurve == null) {
		try {
			ivjcbCompressedCurve = new java.awt.Checkbox();
			ivjcbCompressedCurve.setName("cbCompressedCurve");
			ivjcbCompressedCurve.setFont(new java.awt.Font("Arial", 1, 14));
			ivjcbCompressedCurve.setBounds(10, 500, 200, 20);
			ivjcbCompressedCurve.setLabel("Compressed curve");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjcbCompressedCurve;
}

/**
 * Return the Checkbox1 property value.
 * @return java.awt.Checkbox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Checkbox getcbDetails() {
	if (ivjcbDetails == null) {
		try {
			ivjcbDetails = new java.awt.Checkbox();
			ivjcbDetails.setName("cbDetails");
			ivjcbDetails.setFont(new java.awt.Font("Arial", 1, 14));
			ivjcbDetails.setBounds(10, 600, 200, 20);
			ivjcbDetails.setLabel("Details");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjcbDetails;
}

/**
 * Return the Checkbox2 property value.
 * @return java.awt.Checkbox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Checkbox getcbPolygon() {
	if (ivjcbPolygon == null) {
		try {
			ivjcbPolygon = new java.awt.Checkbox();
			ivjcbPolygon.setName("cbPolygon");
			ivjcbPolygon.setFont(new java.awt.Font("Arial", 1, 14));
			ivjcbPolygon.setBounds(10, 520, 200, 20);
			ivjcbPolygon.setLabel("Initial polygon");
			ivjcbPolygon.setState(true);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjcbPolygon;
}

/**
 * Return the Checkbox2 property value.
 * @return java.awt.Checkbox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Checkbox getcbControlPoints() {
	if (ivjcbControlPoints == null) {
		try {
			ivjcbControlPoints = new java.awt.Checkbox();
			ivjcbControlPoints.setName("cbControlPoints");
			ivjcbControlPoints.setFont(new java.awt.Font("Arial", 1, 14));
			ivjcbControlPoints.setBounds(10, 560, 200, 20);
			ivjcbControlPoints.setLabel("Control points");
			ivjcbControlPoints.setState(true);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjcbControlPoints;
}

/**
 * Return the Checkbox1 property value.
 * @return java.awt.Checkbox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Checkbox getcbDecomposedPolygon() {
	if (ivjcbDecomposedPolygon == null) {
		try {
			ivjcbDecomposedPolygon = new java.awt.Checkbox();
			ivjcbDecomposedPolygon.setName("cbDecomposedPolygon");
			ivjcbDecomposedPolygon.setFont(new java.awt.Font("Arial", 1, 14));
			ivjcbDecomposedPolygon.setBounds(10, 540, 200, 20);
			ivjcbDecomposedPolygon.setLabel("Decomposed polygon");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjcbDecomposedPolygon;
}

/**
 * Return the Checkbox3 property value.
 * @return java.awt.Checkbox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Checkbox getcdDecomposedPoints() {
	if (ivjcdDecomposedPoints == null) {
		try {
			ivjcdDecomposedPoints = new java.awt.Checkbox();
			ivjcdDecomposedPoints.setName("cdDecomposedPoints");
			ivjcdDecomposedPoints.setFont(new java.awt.Font("Arial", 1, 14));
			ivjcdDecomposedPoints.setBounds(10, 580, 200, 20);
			ivjcdDecomposedPoints.setLabel("Decomposed points");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjcdDecomposedPoints;
}


	/***********************************************************************************************/
	/***********************************************************************************************/


/**
 * Return the Label1 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getlNbControlPoints() {
	if (ivjlNbControlPoints == null) {
		try {
			ivjlNbControlPoints = new java.awt.Label();
			ivjlNbControlPoints.setName("lNbControlPoints");
			ivjlNbControlPoints.setFont(new java.awt.Font("Arial", 1, 14));
			ivjlNbControlPoints.setAlignment(java.awt.Label.CENTER);
			ivjlNbControlPoints.setText("Nb control points :");
			ivjlNbControlPoints.setBounds(0, 20, 130, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlNbControlPoints;
}

/**
 * Return the Label3 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getlNbDecompositions() {
	if (ivjlNbDecompositions == null) {
		try {
			ivjlNbDecompositions = new java.awt.Label();
			ivjlNbDecompositions.setName("lNbDecompositions");
			ivjlNbDecompositions.setFont(new java.awt.Font("Arial", 1, 14));
			ivjlNbDecompositions.setAlignment(java.awt.Label.CENTER);
			ivjlNbDecompositions.setText("Nb decomp           :");
			ivjlNbDecompositions.setBounds(0, 60, 130, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlNbDecompositions;
}

/**
 * Return the Label2 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getlNbPoints() {
	if (ivjlNbPoints == null) {
		try {
			ivjlNbPoints = new java.awt.Label();
			ivjlNbPoints.setName("lNbPoints");
			ivjlNbPoints.setFont(new java.awt.Font("Arial", 1, 14));
			ivjlNbPoints.setAlignment(java.awt.Label.CENTER);
			ivjlNbPoints.setText("Number of points :");
			ivjlNbPoints.setBounds(0, 40, 130, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlNbPoints;
}

/**
 * Return the Label5 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getnbControlPoints() {
	if (ivjnbControlPoints == null) {
		try {
			ivjnbControlPoints = new java.awt.Label();
			ivjnbControlPoints.setName("nbControlPoints");
			ivjnbControlPoints.setFont(new java.awt.Font("Arial", 1, 14));
			ivjnbControlPoints.setAlignment(java.awt.Label.CENTER);
			ivjnbControlPoints.setText("0");
			ivjnbControlPoints.setBounds(130, 20, 70, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjnbControlPoints;
}

/**
 * Return the Label4 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getnbDecompositions() {
	if (ivjnbDecompositions == null) {
		try {
			ivjnbDecompositions = new java.awt.Label();
			ivjnbDecompositions.setName("nbDecompositions");
			ivjnbDecompositions.setFont(new java.awt.Font("Arial", 1, 14));
			ivjnbDecompositions.setAlignment(java.awt.Label.CENTER);
			ivjnbDecompositions.setText("0");
			ivjnbDecompositions.setBounds(130, 60, 70, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjnbDecompositions;
}

/**
 * Return the Label6 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getnbPoints() {
	if (ivjnbPoints == null) {
		try {
			ivjnbPoints = new java.awt.Label();
			ivjnbPoints.setName("nbPoints");
			ivjnbPoints.setFont(new java.awt.Font("Arial", 1, 14));
			ivjnbPoints.setAlignment(java.awt.Label.CENTER);
			ivjnbPoints.setText("0");
			ivjnbPoints.setBounds(130, 40, 70, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjnbPoints;
}

/**
 * Return the Label4 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getlDecomposedCurve() {
	if (ivjlDecomposedCurve == null) {
		try {
			ivjlDecomposedCurve = new java.awt.Label();
			ivjlDecomposedCurve.setName("lDecomposedCurve");
			ivjlDecomposedCurve.setFont(new java.awt.Font("Arial", 1, 18));
			ivjlDecomposedCurve.setText("Decomposed curve");
			ivjlDecomposedCurve.setBounds(0, 100, 200, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlDecomposedCurve;
}

/**
 * Return the Label3 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getlInitialCurve() {
	if (ivjlInitialCurve == null) {
		try {
			ivjlInitialCurve = new java.awt.Label();
			ivjlInitialCurve.setName("lInitialCurve");
			ivjlInitialCurve.setFont(new java.awt.Font("Arial", 1, 18));
			ivjlInitialCurve.setText("Initial curve");
			ivjlInitialCurve.setBounds(0, 0, 200, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlInitialCurve;
}

/**
 * Return the Label2 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getlnbControlPointsDecomposed() {
	if (ivjlnbControlPointsDecomposed == null) {
		try {
			ivjlnbControlPointsDecomposed = new java.awt.Label();
			ivjlnbControlPointsDecomposed.setName("lnbControlPointsDecomposed");
			ivjlnbControlPointsDecomposed.setFont(new java.awt.Font("Arial", 1, 14));
			ivjlnbControlPointsDecomposed.setText("Nb control points :");
			ivjlnbControlPointsDecomposed.setBounds(0, 120, 130, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlnbControlPointsDecomposed;
}

/**
 * Return the Label1 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getlnbPointsDecomposed() {
	if (ivjlnbPointsDecomposed == null) {
		try {
			ivjlnbPointsDecomposed = new java.awt.Label();
			ivjlnbPointsDecomposed.setName("lnbPointsDecomposed");
			ivjlnbPointsDecomposed.setFont(new java.awt.Font("Arial", 1, 14));
			ivjlnbPointsDecomposed.setText("Nb points              :");
			ivjlnbPointsDecomposed.setBounds(0, 140, 130, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlnbPointsDecomposed;
}

/**
 * Return the Label6 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getnbDecomposedControlPoints() {
	if (ivjnbDecomposedControlPoints == null) {
		try {
			ivjnbDecomposedControlPoints = new java.awt.Label();
			ivjnbDecomposedControlPoints.setName("nbDecomposedControlPoints");
			ivjnbDecomposedControlPoints.setFont(new java.awt.Font("Arial", 1, 14));
			ivjnbDecomposedControlPoints.setAlignment(java.awt.Label.CENTER);
			ivjnbDecomposedControlPoints.setText("0");
			ivjnbDecomposedControlPoints.setBounds(130, 120, 70, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjnbDecomposedControlPoints;
}

/**
 * Return the Label5 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getnbDecomposedPoints() {
	if (ivjnbDecomposedPoints == null) {
		try {
			ivjnbDecomposedPoints = new java.awt.Label();
			ivjnbDecomposedPoints.setName("nbDecomposedPoints");
			ivjnbDecomposedPoints.setFont(new java.awt.Font("Arial", 1, 14));
			ivjnbDecomposedPoints.setAlignment(java.awt.Label.CENTER);
			ivjnbDecomposedPoints.setText("0");
			ivjnbDecomposedPoints.setBounds(130, 140, 70, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjnbDecomposedPoints;
}

/**
 * Return the lNbSubdiv property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getlNbSubdiv() {
	if (ivjlNbSubdiv == null) {
		try {
			ivjlNbSubdiv = new java.awt.Label();
			ivjlNbSubdiv.setName("lNbSubdiv");
			ivjlNbSubdiv.setFont(new java.awt.Font("Arial", 1, 14));
			ivjlNbSubdiv.setText("Nb subdiv             :");
			ivjlNbSubdiv.setBounds(0, 80, 130, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlNbSubdiv;
}

/**
 * Return the nbSubdiv property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Label getnbSubdiv() {
	if (ivjnbSubdiv == null) {
		try {
			ivjnbSubdiv = new java.awt.Label();
			ivjnbSubdiv.setName("nbSubdiv");
			ivjnbSubdiv.setFont(new java.awt.Font("Arial", 1, 14));
			ivjnbSubdiv.setAlignment(java.awt.Label.CENTER);
			ivjnbSubdiv.setText("0");
			ivjnbSubdiv.setBounds(130, 80, 70, 20);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjnbSubdiv;
}


	/***********************************************************************************************/
	/***********************************************************************************************/


/**
 * Comment
 */
public void cbControlPoints_ItemStateChanged(java.awt.event.ItemEvent itemEvent) {
	
	if (itemEvent.getStateChange()==java.awt.event.ItemEvent.SELECTED)		
		showControlPoints = true;
	else
		showControlPoints = false;
		
	repaint();paintall();
	
}

/**
 * Comment
 */
public void cbCurve_ItemStateChanged(java.awt.event.ItemEvent itemEvent) {

	if (itemEvent.getStateChange()==java.awt.event.ItemEvent.SELECTED)	
		showInitialCurve = true;
	else
		showInitialCurve = false;
			
	repaint();paintall();
	
}

/**
 * Comment
 */
public void cbDecomposedCurve_ItemStateChanged(java.awt.event.ItemEvent itemEvent) {

	if (itemEvent.getStateChange()==java.awt.event.ItemEvent.SELECTED)	
		showDecomposedCurve = true;
	else
		showDecomposedCurve = false;
		
	repaint();paintall();
	
}

/**
 * Comment
 */
public void cbCompressedCurve_ItemStateChanged(java.awt.event.ItemEvent itemEvent) {

	if (itemEvent.getStateChange()==java.awt.event.ItemEvent.SELECTED)	
		showCompressedCurve = true;
	else
		showCompressedCurve = false;
		
	repaint();paintall();
	
}

/**
 * Comment
 */
public void cbDecomposedPolygon_ItemStateChanged(java.awt.event.ItemEvent itemEvent) {
	
	if (itemEvent.getStateChange()==java.awt.event.ItemEvent.SELECTED)	
		showDecomposedPolygon = true;
	else
		showDecomposedPolygon = false;
		
	repaint();paintall();
	
}

/**
 * Comment
 */
public void cbDetails_ItemStateChanged(java.awt.event.ItemEvent itemEvent) {

	if (itemEvent.getStateChange()==java.awt.event.ItemEvent.SELECTED)		
		showDetails = true;
	else
		showDetails = false;
		
	repaint();paintall();
	
}

/**
 * Comment
 */
public void cbPolygon_ItemStateChanged(java.awt.event.ItemEvent itemEvent) {
	
	if (itemEvent.getStateChange()==java.awt.event.ItemEvent.SELECTED)	
		showInitialPolygon = true;
	else
		showInitialPolygon = false;
		
	repaint();paintall();
	
}

/**
 * Comment
 */
public void cdDecomposedPoints_ItemStateChanged(java.awt.event.ItemEvent itemEvent) {

	if (itemEvent.getStateChange()==java.awt.event.ItemEvent.SELECTED)	
		showDecomposedControlPoints=true;
	else
		showDecomposedControlPoints=false;
		
	repaint();paintall();
	
}


	/***********************************************************************************************/
	/***********************************************************************************************/


/**
 * Comment
 */
public void bReset_MouseClicked(java.awt.event.MouseEvent mouseEvent) {
	reset();
	repaint();paintall();
	
}

/**
 * Comment
 */
public void bHistogramm_MouseClicked(java.awt.event.MouseEvent mouseEvent) {

	state = (state+1)%3;
	if (state==0)
		getbHistogramm().setLabel("Histogramm");
	else if (state==1)
		getbHistogramm().setLabel("Compression error");
	else if (state==2)
		getbHistogramm().setLabel("Curve");

	repaint();paintall();
		
}

/**
 * Comment
 */
public void bCompress_MouseClicked(java.awt.event.MouseEvent mouseEvent) {

	double d = new Double(gettfCompress().getText()).doubleValue();
	sc3.compress(d);
	repaint();paintall();
		
}

/**
 * Comment
 */
 public void drawingPanel_MouseClicked(java.awt.event.MouseEvent mouseEvent) {

	if ((mouseEvent.getModifiers() & InputEvent.BUTTON1_MASK)!=0) {
		if (sc.getNumSelectedControlPoint()==-1) {
			sc.addControlPoint(mouseEvent.getX(),mouseEvent.getY());
			nbControlPoints++;
		}
		else
			sc.moveSelectedControlPoint(mouseEvent.getX(),mouseEvent.getY());
		sc2.setControlPoints(sc.getControlPoints());
		nbDecompositions = sc2.reDecompose();
		sc3.setControlPoints(sc.getControlPoints());
		nbDecompositions = sc3.reDecompose();
		repaint();paintall();
	}
	else if ((mouseEvent.getModifiers() & InputEvent.BUTTON2_MASK)!=0 && sc.getNumSelectedControlPoint()!=-1) {
		sc.removeSelectedControlPoint();
		nbControlPoints--;
		sc2.setControlPoints(sc.getControlPoints());
		nbDecompositions = sc2.reDecompose();
		sc3.setControlPoints(sc.getControlPoints());
		nbDecompositions = sc3.reDecompose();

		repaint();paintall();
	}
	else if ((mouseEvent.getModifiers() & InputEvent.BUTTON3_MASK)!=0) {
		sc.selectCloserControlPoint(mouseEvent.getX(),mouseEvent.getY(),3);
		repaint();paintall();
	}
	
}


	/***********************************************************************************************/
	/***********************************************************************************************/


/**
 * Comment
 */
public void drawingPanel_MouseDragged(java.awt.event.MouseEvent mouseEvent) {
	if ((mouseEvent.getModifiers() & InputEvent.BUTTON1_MASK)!=0) {
		if (sc.getNumSelectedControlPoint()==-1) {
			sc.addControlPoint(mouseEvent.getX(),mouseEvent.getY());
			nbControlPoints++;
		}
		else
			sc.moveSelectedControlPoint(mouseEvent.getX(),mouseEvent.getY());
		sc2.setControlPoints(sc.getControlPoints());
		nbDecompositions = sc2.reDecompose();
		sc3.setControlPoints(sc.getControlPoints());
		nbDecompositions = sc3.reDecompose();

	}
	else if ((mouseEvent.getModifiers() & InputEvent.BUTTON3_MASK)!=0)
		sc.selectCloserControlPoint(mouseEvent.getX(),mouseEvent.getY(),3);
	
	repaint();paintall();
}


	/***********************************************************************************************/
	/***********************************************************************************************/


/**
 * Return the Panel1 property value.
 * @return java.awt.Panel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Panel getcontrolPanel() {
	if (ivjcontrolPanel == null) {
		try {
			ivjcontrolPanel = new java.awt.Panel();
			ivjcontrolPanel.setName("controlPanel");
			ivjcontrolPanel.setLayout(null);
			ivjcontrolPanel.setBackground(java.awt.SystemColor.activeCaptionBorder);
			ivjcontrolPanel.setBounds(0, 0, 200, 620);
			getcontrolPanel().add(getlNbControlPoints(), getlNbControlPoints().getName());
			getcontrolPanel().add(getnbControlPoints(), getnbControlPoints().getName());
			getcontrolPanel().add(getlNbPoints(), getlNbPoints().getName());
			getcontrolPanel().add(getnbPoints(), getnbPoints().getName());
			getcontrolPanel().add(getlNbDecompositions(), getlNbDecompositions().getName());
			getcontrolPanel().add(getnbDecompositions(), getnbDecompositions().getName());
			getcontrolPanel().add(getbSubdivide(), getbSubdivide().getName());
			getcontrolPanel().add(getbUndo(), getbUndo().getName());
			getcontrolPanel().add(getbDecompose(), getbDecompose().getName());
			getcontrolPanel().add(getbReconstruct(), getbReconstruct().getName());
			getcontrolPanel().add(getbLoadCircle(), getbLoadCircle().getName());
			getcontrolPanel().add(getbLoadHeart(), getbLoadHeart().getName());
			getcontrolPanel().add(getbLoadLissajou(), getbLoadLissajou().getName());
			getcontrolPanel().add(getbLoadLoop(), getbLoadLoop().getName());
			getcontrolPanel().add(getlNbSubdiv(), getlNbSubdiv().getName());
			getcontrolPanel().add(getnbSubdiv(), getnbSubdiv().getName());
			getcontrolPanel().add(getlnbPointsDecomposed(), getlnbPointsDecomposed().getName());
			getcontrolPanel().add(getlnbControlPointsDecomposed(), getlnbControlPointsDecomposed().getName());
			getcontrolPanel().add(getbReset(), getbReset().getName());
			getcontrolPanel().add(getlInitialCurve(), getlInitialCurve().getName());
			getcontrolPanel().add(getlDecomposedCurve(), getlDecomposedCurve().getName());
			getcontrolPanel().add(getnbDecomposedPoints(), getnbDecomposedPoints().getName());
			getcontrolPanel().add(getnbDecomposedControlPoints(), getnbDecomposedControlPoints().getName());
			getcontrolPanel().add(getcbCurve(), getcbCurve().getName());
			getcontrolPanel().add(getcbDecomposedCurve(), getcbDecomposedCurve().getName());
			getcontrolPanel().add(getcbCompressedCurve(), getcbCompressedCurve().getName());
			getcontrolPanel().add(getcbPolygon(), getcbPolygon().getName());
			getcontrolPanel().add(getcbDecomposedPolygon(), getcbDecomposedPolygon().getName());
			getcontrolPanel().add(getcbControlPoints(), getcbControlPoints().getName());
			getcontrolPanel().add(getcdDecomposedPoints(), getcdDecomposedPoints().getName());
			getcontrolPanel().add(getcbDetails(), getcbDetails().getName());
			getcontrolPanel().add(getbHistogramm(), getbHistogramm().getName());
			getcontrolPanel().add(getbCompress(), getbCompress().getName());
			getcontrolPanel().add(gettfCompress(), gettfCompress().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjcontrolPanel;
}

/**
 * Return the Panel2 property value.
 * @return java.awt.Panel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.Panel getdrawingPanel() {
	if (ivjdrawingPanel == null) {
		try {
			ivjdrawingPanel = new java.awt.Panel();
			ivjdrawingPanel.setName("drawingPanel");
			ivjdrawingPanel.setLayout(null);
			ivjdrawingPanel.setBackground(java.awt.Color.black);
			ivjdrawingPanel.setBounds(200, 0, 600, 620);
			ivjdrawingPanel.setVisible(true);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjdrawingPanel;
}


	/***********************************************************************************************/
	/***********************************************************************************************/


/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}

/**
 * Initializes the applet.
 */
public void init() {
	try {
		super.init();
		setName("Subdiv");
		setLayout(null);
		setSize(800, 620);
		add(getcontrolPanel(), getcontrolPanel().getName());
		add(getdrawingPanel(), getdrawingPanel().getName());
		initConnections();
		// user code begin {1}
		
		reset();
		showInitialCurve 		= true;
		showDecomposedCurve 		= false;
		showCompressedCurve 		= false;
		showInitialPolygon 		= true;
		showDecomposedPolygon 		= false;
		showControlPoints 		= true;
		showDecomposedControlPoints	= false;
		showDetails 			= false;
		state 				= 0;
		slices 				= 10;
		
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {2}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	getbSubdivide().addMouseListener(ivjEventHandler);
	getbUndo().addMouseListener(ivjEventHandler);
	getbDecompose().addMouseListener(ivjEventHandler);
	getbReconstruct().addMouseListener(ivjEventHandler);
	getbLoadCircle().addMouseListener(ivjEventHandler);
	getbLoadHeart().addMouseListener(ivjEventHandler);
	getbLoadLissajou().addMouseListener(ivjEventHandler);
	getbLoadLoop().addMouseListener(ivjEventHandler);
	getdrawingPanel().addMouseListener(ivjEventHandler);
	getdrawingPanel().addMouseMotionListener(ivjEventHandler);
	getbReset().addMouseListener(ivjEventHandler);
	getcbCurve().addItemListener(ivjEventHandler);
	getcbCompressedCurve().addItemListener(ivjEventHandler);
	getcbDecomposedCurve().addItemListener(ivjEventHandler);
	getcbPolygon().addItemListener(ivjEventHandler);
	getcbDecomposedPolygon().addItemListener(ivjEventHandler);
	getcbControlPoints().addItemListener(ivjEventHandler);
	getcdDecomposedPoints().addItemListener(ivjEventHandler);
	getcbDetails().addItemListener(ivjEventHandler);
	getbHistogramm().addMouseListener(ivjEventHandler);
	getbCompress().addMouseListener(ivjEventHandler);
}

/**
 * Returns information about this applet.
 * @return a string of information about this applet
 */
public String getAppletInfo() {
	return "Subdiv\n" + 
		"\n" + 
		"Insert the type's description here.\n" + 
		"Creation date: (21/02/2001 13:55:51)\n" + 
		"@author: Administrator\n" + 
		"";
}

/**
 * Insert the method's description here.
 * Creation date: (22/02/2001 17:11:49)
 */
public void reset() {

	sc  = new subdivCurve();
	sc2 = new subdivCurve();
	sc3 = new subdivCurve();

	nbControlPoints  = 0;
	nbDecompositions = 0;
	nbSubdivisions	 = 0;
	
}


/**
 * Paints the applet.
 * If the applet does not need to be painted (e.g. if it is only a container for other
 * awt components) then this method can be safely removed.
 * 
 * @param g  the specified Graphics window
 * @see #update
 */
//public void paint(Graphics g) {
public void paintall() {
	//super.paint(g);

	// insert code to paint the applet here
	Vector cp,d,classes,cpc;
	int dx,dy,x,y,endStr;
	double max,nb,minDetail,maxDetail,step;
	String str;
	double theX[] = new double[nbControlPoints];
	double theY[] = new double[nbControlPoints];
	
	Graphics gg = getdrawingPanel().getGraphics();
		
	gg.clearRect(0,0,600,620);

	if (state==0) {

		if (showInitialPolygon) {
			gg.setColor(Color.red);	
			gg.drawPolygon(sc.getControlPolygon());
		}
	
		if (showControlPoints) {
			gg.setColor(Color.red);	cp = sc.getControlPoints();
			for(int i=0;i<cp.size();i++) {
				gg.drawRect((int)(((coord2D)(cp.elementAt(i))).x)-2,(int)(((coord2D)(cp.elementAt(i))).y)-2,4,4);
				if (i==sc.getNumSelectedControlPoint())
					gg.drawOval((int)(((coord2D)(cp.elementAt(i))).x)-8,(int)(((coord2D)(cp.elementAt(i))).y)-8,16,16);
			}
		}

		if (showInitialCurve) {
			gg.setColor(Color.blue);	
			gg.drawPolygon(sc.getInterpolatedPolygon());
		}

		if (showDecomposedPolygon) {
			gg.setColor(Color.green);	
			gg.drawPolygon(sc2.getControlPolygon());
		}

		if (showDecomposedControlPoints) {	
			gg.setColor(Color.green);	
			cp = sc2.getControlPoints();
			for(int i=0;i<cp.size();i++)
				gg.drawRect((int)(((coord2D)(cp.elementAt(i))).x)-2,(int)(((coord2D)(cp.elementAt(i))).y)-2,4,4);
		}

		if (showDecomposedCurve) {
			gg.setColor(Color.yellow);	
			gg.drawPolygon(sc2.getInterpolatedPolygon());
		}

		if (showCompressedCurve) {
			gg.setColor(Color.magenta);	
			gg.drawPolygon(sc3.getInterpolatedPolygon());
		}		
		
		if (showDetails && sc2.getDetails()!=null) {
 	 		d = sc2.getDetails();
  		cp = sc2.getControlPoints();
  		gg.setColor(Color.white);	
			for(int i=0;i<d.size();i++){
				x = (int)(((coord2D)(cp.elementAt(i))).x);
				y = (int)(((coord2D)(cp.elementAt(i))).y);
				dx =(int)(((coord2D)(d.elementAt(i))).x);
				dy =(int)(((coord2D)(d.elementAt(i))).y);
				gg.drawLine(x,y,x+dx,y+dy);
			}
		}
	}
	else if (state==1) {
		gg.setColor(Color.white);
		gg.drawLine(50,550,550,550);
		gg.drawLine(550,550,545,555);
		gg.drawLine(550,550,545,545);
		gg.drawLine(50,550,50,50);
		gg.drawLine(50,50,55,55);
		gg.drawLine(50,50,45,55);
		classes = sc2.computeHistogramm(slices);				
		if (sc2.getDetails()==null) {
			nb =1;
			max = 1;
		}
		else {
			nb =  (sc2.getDetails()).size();				
			max = sc2.getMaxClass();
		}
		minDetail = sc2.getMinDetail();
		maxDetail = sc2.getMaxDetail();
		gg.drawString("0",45,565);
		for(int i=0;i<slices;i++) {
			x = ((Integer)((classes.elementAt(i)))).intValue();			
			gg.drawLine((int)(450.0/slices*(i)+50),(int)(550-450.0/max*x),(int)(450.0/slices*(i)+50),550);
			gg.drawLine((int)(450.0/slices*i+50),(int)(550-450.0/max*x),(int)(450.0/slices*(i+1)+50),(int)(550-450.0/max*x));
			gg.drawLine((int)(450.0/slices*(i+1)+50),(int)(550-450.0/max*x),(int)(450.0/slices*(i+1)+50),550);
			str = Double.toString(x/nb*100);			
			endStr=5;
			if (str.length()<5)
				endStr = str.length();
			gg.drawString(str.substring(0,endStr)+"%",(int)(450.0/slices*(i)+55),(int)(550-450.0/max*x-10));
			str = Double.toString(minDetail+(maxDetail-minDetail)/slices*i);			
			endStr=5;
			if (str.length()<5)
				endStr = str.length();
			gg.drawString(str.substring(0,endStr),(int)(450.0/slices*(i)+85),565);
		}

	}
	else if (state==2) {

		gg.setColor(Color.white);
		gg.drawLine(50,550,550,550);
		gg.drawLine(550,550,545,555);
		gg.drawLine(550,550,545,545);
		gg.drawLine(50,550,50,50);
		gg.drawLine(50,50,55,55);
		gg.drawLine(50,50,45,55);

		if (nbDecompositions==0) {
			cp  = sc2.getControlPoints();
			cpc = sc3.getControlPoints();
			max=0;
			for(int i=0;i<nbControlPoints;i++) {
				theX[i] = ((coord2D)(cp.elementAt(i))).x-((coord2D)(cpc.elementAt(i))).x;
				theY[i] = ((coord2D)(cp.elementAt(i))).y-((coord2D)(cpc.elementAt(i))).y;
				theY[i] = Math.sqrt(theX[i]*theX[i]+theY[i]*theY[i]);
				if (theY[i]>max)
					max = theY[i];
			}
			
			step = 500.0/(double)nbControlPoints;
			for(double i=0;i<max;i+=max/10.0) {
				gg.drawLine(45,550-(int)(i*500.0/max),55,550-(int)(i*500.0/max));
				str = Double.toString(i);
				endStr=5;
				if (str.length()<5)
					endStr = str.length();
				gg.drawString(str.substring(0,endStr),10,555-(int)(i*500.0/max));

			}

			for(int i=0;i<nbControlPoints-1;i++) {
				gg.drawLine((int)(step*i)+50,550-(int)(theY[i]*500.0/max),(int)(step*(i+1))+50,550-(int)(theY[i+1]*500.0/max));
				if (i%10==0) {
					gg.drawLine((int)(step*i)+50,555,(int)(step*i)+50,545);
					gg.drawString(Integer.toString(i),(int)(step*i)+45,570);
				}
			}
		}
					
	}

	ivjnbControlPoints.setText(Integer.toString(nbControlPoints));
	ivjnbPoints.setText(Integer.toString(nbControlPoints*(int)(Math.pow(2.0,(double)nbSubdivisions))));
	ivjnbDecompositions.setText(Integer.toString(nbDecompositions));
	ivjnbSubdiv.setText(Integer.toString(nbSubdivisions));
	ivjnbDecomposedControlPoints.setText(Integer.toString(nbControlPoints/(int)(Math.pow(2.0,(double)nbDecompositions))));
	ivjnbDecomposedPoints.setText(Integer.toString(nbControlPoints/(int)(Math.pow(2.0,(double)nbDecompositions))*(int)(Math.pow(2.0,(double)nbSubdivisions))));
		
}

/**
 * main entrypoint - starts the part when it is run as an application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args) {
	try {
		Frame frame = new java.awt.Frame();
		Subdiv aSubdiv;
		Class iiCls = Class.forName("Subdiv");
		ClassLoader iiClsLoader = iiCls.getClassLoader();
		aSubdiv = (Subdiv)java.beans.Beans.instantiate(iiClsLoader,"Subdiv");
		frame.add("Center", aSubdiv);
		frame.setSize(aSubdiv.getSize());
		frame.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			};
		});
		frame.show();
		java.awt.Insets insets = frame.getInsets();
		frame.setSize(frame.getWidth() + insets.left + insets.right, frame.getHeight() + insets.top + insets.bottom);
		frame.setVisible(true);
		
	} catch (Throwable exception) {
		System.err.println("Exception occurred in main() of java.applet.Applet");
		exception.printStackTrace(System.out);
	}
}

	/***********************************************************************************************/
	/***********************************************************************************************/	

}


